<?php if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

class AdsGostar_SMS_Bulk {

	public function __construct() {

		add_action( 'agoosms_settings_form_bottom_sms_send', array( $this, 'bulkForm' ) );
		add_action( 'agoosms_settings_form_admin_notices', array( $this, 'bulkNotice' ), 10 );

		if ( AGWooSMS()->Options( 'enable_buyer' ) ) {
			add_action( 'admin_footer', array( $this, 'bulkScript' ), 10 );
			add_action( 'load-edit.php', array( $this, 'bulkAction' ) );
		}
	}

	public function bulkForm() { ?>

	<div >

	</div>
        <form class="initial-form" id="agoosms-send-sms-bulk-form" method="post"
              action="<?php echo admin_url( 'admin.php?page=persian-adsgostar-sms-pro&tab=send' ) ?>">

			<?php wp_nonce_field( 'agoosms_send_sms_nonce', '_wpnonce' ); ?>

            <p>
                <label for="agoosms_mobile">شماره دریافت کننده</label><br>
                <input type="text" name="agoosms_mobile" id="agoosms_mobile"
                       value="<?php echo isset( $_POST['agoosms_mobile'] ) ? sanitize_text_field( $_POST['agoosms_mobile'] ) : '' ?>"
                       style="direction:ltr; text-align:left; width:100%; !important"/><br>
                <span>شماره موبایل دریافت کننده واتساپ  را وارد کنید. شماره ها را با کاما (,) جدا نمایید.</span>
            </p>

            <p>
                <label for="agoosms_message">متن واتساپ </label><br>
                <textarea name="agoosms_message" id="agoosms_message" rows="10"
                          style="width:100% !important"><?php echo ! empty( $_POST['agoosms_message'] ) ? strip_tags( $_POST['agoosms_message'], '<br>' ) : '' ?></textarea><br>
                <span>متن دلخواهی که میخواهید به دریافت کننده ارسال کنید را وارد کنید.</span>
            </p>

            <p>
                <input type="submit" class="button button-primary" name="agoosms_send_sms"
                       value="ارسال واتساپ ">
            </p>
        </form>
		<?php
	}

	public function bulkNotice() {

		if ( isset( $_POST['agoosms_send_sms'] ) ) {

			if ( empty( $_POST['_wpnonce'] ) || ! wp_verify_nonce( $_POST['_wpnonce'], 'agoosms_send_sms_nonce' ) ) {
				wp_die( 'خطایی رخ داده است.' );
			}

			$data            = array();
			$data['type']    = 1;
			$data['mobile']  = $mobiles = ! empty( $_POST['agoosms_mobile'] ) ? explode( ',', sanitize_text_field( $_POST['agoosms_mobile'] ) ) : array();
			$data['message'] = ! empty( $_POST['agoosms_message'] ) ? esc_textarea( $_POST['agoosms_message'] ) : '';

			$response = AGWooSMS()->SendSMS( $data );
			if ( $response === true ) { ?>
                <div class="notice notice-success below-h2">
                    <p>واتساپ  با موفقیت ارسال شد.<br><strong>تعداد مخاطبین با حذف شماره های
                            تکراری </strong>=> <?php echo count( $mobiles ) . ' شماره '; ?></p>
                </div>
				<?php
				return true;
			} ?>

            <div class="notice notice-error below-h2">
                <p><strong>خطا: </strong>واتساپ  ارسال نشد. پاسخ وبسرویس:
					<?php echo $response; ?>
                </p>
            </div>
			<?php
		}

		return false;
	}

	public function bulkScript() {

		global $post_type;
		if ( 'shop_order' == $post_type ) : ?>
            <script type="text/javascript">
                jQuery(function () {
                    jQuery('<option>').val('send_sms').text('ارسال واتساپ  دسته جمعی').appendTo("select[name='action']");
                    jQuery('<option>').val('send_sms').text('ارسال واتساپ  دسته جمعی').appendTo("select[name='action2']");
                });
            </script>
		<?php
		endif;
	}

	public function bulkAction() {

		$wp_list_table = _get_list_table( 'WP_Posts_List_Table' );
		$action        = $wp_list_table->current_action();
		if ( $action != 'send_sms' ) {
			return;
		}

		$post_ids = array_map( 'absint', (array) $_REQUEST['post'] );
		$mobiles  = array();
		foreach ( $post_ids as $order_id ) {
			$mobiles[] = AGWooSMS()->buyerMobile( $order_id );
		}

		$mobiles = implode( ',', array_unique( array_filter( $mobiles ) ) );

		echo '<form method="POST" name="agoosms_posted_form" action="' . admin_url( 'admin.php?page=persian-adsgostar-sms-pro&tab=send' ) . '">
		<input type="hidden" value="' . $mobiles . '" name="agoosms_mobile" />
		</form>
		<script language="javascript" type="text/javascript">document.agoosms_posted_form.submit(); </script>';
		exit();
	}
}

new AdsGostar_SMS_Bulk();