<?php if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

class AdsGostar_SMS_Gfsw {

	public function __construct() {
		add_action( 'admin_init', array( $this, 'adminInit' ) );
		add_filter( 'agoosms_settings_sections', array( $this, 'addSection' ), 9999, 1 );
		add_action( 'agoosms_settings_form_bottom_sms_gfsw', array( $this, 'gfswPage' ) );
		add_action( 'wp_ajax_agoosms_hide_gfsw_page', array( $this, 'ajaxCallback' ) );
	}

	public function addSection( $sections ) {

		if ( ! get_option( 'agoosms_hide_gfsw_page' ) ) {
			$sections[] = array(
				'id'       => 'sms_gfsw',
				'title'    => 'گرویتی فرم',
				'form_tag' => false
			);
		}

		return $sections;
	}

	public function adminInit() {
		if ( ! get_option( 'agoosms_redirect_gfsw_page' ) ) {

			delete_option( 'agoosms_hide_gfsw_page' );
			update_option( 'agoosms_redirect_gfsw_page', '1' );

			if ( ! headers_sent() ) {
				wp_redirect( admin_url( 'admin.php?page=persian-adsgostar-sms-pro&tab=gfsw' ) );
				exit();
			}
		}
	}

	public function ajaxCallback() {
		update_option( 'agoosms_hide_gfsw_page', '1' );
		die();
	}

	public static function gfswPage() {
		$view = rgget( "view" );
		if ( $view == "edit" ) {
			GFKATOUKISMS_Pro_Configurations::configuration();
		} else if ( $view == "send" ) {
			GFKATOUKISMS_Pro_Bulk::send_many_numbers();
		} else if ( $view == "sent" ) {
			GFKATOUKISMS_Pro_Sent::table();
		} else {
			GFKATOUKISMS_Pro_Feeds::feeds( '' );
		}
        ?>

        <style type="text/css">
            a {
                text-decoration: none !important;
            }

            p {
                line-height: 28px !important;
                text-align: justify;
            }
        </style>
        <script type="text/javascript">
            jQuery( document ).on( 'change', '#agoosms_hide_gfsw_page', function () {
                jQuery.ajax( {
                    url: ajaxurl,
                    data: {
                        action: 'agoosms_hide_gfsw_page'
                    }
                } ).done( function () {
                    window.location = "<?php echo admin_url( 'admin.php?page=persian-adsgostar-sms-pro' ); ?>";
                } );
            } )
        </script>
	<?php }
}

new AdsGostar_SMS_Gfsw(); 