<?php if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

if ( ! class_exists( 'GFKATOUKISMS_Pro_WebServices' ) ) {

	class GFKATOUKISMS_Pro_WebServices {

		public static function get() {
			return apply_filters( 'gfs_sms_gateways', array( 'no' => __( 'Select a Gateway', 'GFS_SMS' ) ) );
		}

		public static function action( $settings, $action, $from, $to, $messages ) {

			$gateway = isset( $settings["ws"] ) ? $settings["ws"] : '';

			if ( empty( $gateway ) || $gateway == 'no' ) {
				return __( 'No Gateway found.', 'GFS_SMS' );
			}

			$GATEWAY = strtoupper( $gateway );
			$Gateway = 'GFKATOUKISMS_Pro_' . $GATEWAY;

			$messages = str_replace( array( "<br>", "<br/>", "<br />", '&nbsp;' ), array(
				"\n",
				"\n",
				"\n",
				''
			), $messages );
			$messages = strip_tags( $messages );

			if ( ! class_exists( $Gateway ) && file_exists( GFS_SMS_GATEWAY . strtolower( $gateway ) . '.php' ) ) {
				require_once( GFS_SMS_GATEWAY . strtolower( $gateway ) . '.php' );
			}

			if ( class_exists( $Gateway ) && method_exists( $Gateway, 'process' ) ) {

				/*
				if ( function_exists( 'error_reporting' ) ) {
					$error = error_reporting( E_ALL ^ E_WARNING ^ E_DEPRECATED ^ E_NOTICE );
				}
				*/

				$options = get_option( "gfs_sabasms_". $GATEWAY );
				
				$result  = $Gateway::process( $options, $action, $from, $to, $messages );
				
				/*if ( ! empty( $error ) ) {
					error_reporting( $error );
				}*/

				return $result;
			}

			return __( 'No Gateway found.', 'GFS_SMS' );
		}
	}
}